;**********************************************************************;
;*                 A T O M I C   D E B U G G E R                      *;
;*--------------------------------------------------------------------*;
;*    doel           : machinetaal debugger voor Atom-in-PC met       *;
;*                     ondersteuning van 6502, 65C02 en 65802         *;
;*--------------------------------------------------------------------*;
;*    filenaam       : identcpu.inc                                   *;
;*    auteur         : Roland Leurs                                   *;
;*                     The Atomic Development Studio                  *;
;*    ontwikkeld     : feb 1996                                       *;
;*    laatste update :                                                *;
;*--------------------------------------------------------------------*;
;*    assembleren    : als include opnemen in debug.asm               *;
;**********************************************************************;

;Deze routine bevat 65802 code en is als hex data opgenomen in de source.
;Uitvoer:       6502    accu = #02
;               65C02   accu = #C2
;               65802   accu = #82

whichcpu1       .db     $F8, $A9, $99, $18, $69, $01, $30
                .db     $06, $18, $FB, $90, $02, $FB, $38
                .db     $D8, $60
whichcpu        jsr     whichcpu1
                bmi     cpu_is_6502
                bcs     cpu_is_65802
cpu_is_65c02    lda     #$C2            ;laadt code voor 65c02
                rts
cpu_is_65802    lda     #$82            ;laadt code voor 65802
                rts
cpu_is_6502     lda     #$02            ;laadt code voor 6502
                rts
