/* This file contains routines for communicating with an 8255 */

#ifndef BASEPORT
	#define BASEPORT 0x310
#endif

void initport(void)
	{
	outb(0x9B, BASEPORT+3);	/* alle bits are input */
	regfile[TRISA]=0x1F;
	regfile[TRISB]=0xFF;
	}

int trisa(int command, int status)
	{
	if(command=='w')
		{
		if(status==0x00)
			{
			if(regfile[TRISB] == 0x00)
				{
				outb(0x89, BASEPORT+3);
				}
			if(regfile[TRISB] == 0xFF)
				{
				outb(0x8B, BASEPORT+3);
				}
			regfile[TRISA]=status;
			}
		if(status==0x1F)
			{
			if(regfile[TRISB] == 0x00)
				{
				outb(0x99, BASEPORT+3);
				}
			if(regfile[TRISB] == 0xFF)
				{
				outb(0x9B, BASEPORT+3);
				}
			regfile[TRISA]=status;
			}
		}
	return regfile[TRISA];
	}	

int trisb(int command, int status)
	{
	if(command=='w')
		{
                if(status==0x00)
                        {
                        if(regfile[TRISA] == 0x00)
                                {
                                outb(0x89, BASEPORT+3);
                                }
                        if(regfile[TRISA] == 0x1F)
                                {
                                outb(0x99, BASEPORT+3);
                                }
                        regfile[TRISB]=status;
                        }
                if(status==0xFF)
                        {
                        if(regfile[TRISA] == 0x00)
                                {
                                outb(0x8B, BASEPORT+3);
                                }
                        if(regfile[TRISA] == 0x1F)
                                {
                                outb(0x9B, BASEPORT+3);
                                }
                        regfile[TRISB]=status;
                        }
                }
	return regfile[TRISB];
        }

int porta(int command, int status)
	{
	olda=regfile[PORTA];
	if(command=='w')
		{
		outb(status, BASEPORT);
		}
	regfile[PORTA]=inb(BASEPORT);
	return regfile[PORTA];
	}
	
int portb(int command, int status)
	{
	oldb=regfile[PORTB];
	if(command=='w')
		{
		outb(status, BASEPORT+1);
		}
	regfile[PORTB]=inb(BASEPORT+1);
	return regfile[PORTB];
	}

