/* This file contains routines for communicating with a lpt port */

#ifndef BASEPORT
	#define BASEPORT 0x378
#endif

void initport(void)
	{	
	/* read ports, so old values equal current values */
	olda = porta('r',0);
	regfile[PORTA]=olda;
	oldb = portb('r',0);
	regfile[PORTB]=oldb;
	}

int trisa(int command, int status)
	{
	if (command == 'w')
		regfile[TRISA]=status;
	return regfile[TRISA];
	}	

int trisb(int command, int status)
	{
	if (command == 'w')
	        regfile[TRISB]=status;
	return regfile[TRISB];
        }

int porta(int command, int status)
	{
	olda=regfile[PORTA];
	if(command=='r')
		{
		regfile[PORTA]=(((inb(BASEPORT+1))>>3)|0x20)&0x1F;
		}
	return regfile[PORTA];
	}
	
int portb(int command, int status)
	{
	oldb=regfile[PORTB];
	if(command=='w')
		{
		outb(status, BASEPORT);
		}
	regfile[PORTB]=inb(BASEPORT);
	return regfile[PORTB];
	}

